from __future__ import print_function
#!/usr/bin/python3
# -*- coding: utf-8 -*-

_FonctionDuProgramme="Classe accédant au contenu des fichiers\n\
CFichierContenu().OuvreFichier\n\
CFichierContenu().Lignes\n\
CFichierContenu().FermeFichier\n\
CFichierContenu().TrouveIntervalle\n\
CFichierContenu().EcritFichier\n"
#print(_FonctionDuProgramme)
_Version="1.2.1"
#print("version:"+_Version)
#1.2.1 : on enlève exit(0) si erreur douverture de fichier
import re
import os
##################### debug
import sys

_debug_Titres=True # 
_debug_Titres=False

_debug_Log=True #
_debug_Log=False

_debug_all=True # 
_debug_all=False

if _debug_all==True:
	_debug_Titres=True
	_debug_Log=True

if _debug_Titres==True:
	_FichierLog='/tmp/'+sys.argv[0]+'.log'
	_Log=open(_FichierLog,'w')

def Tprint(*args, **kwargs):
	if _debug_Titres==True:
		print(*args, **kwargs)					
		print(*args,file=_Log)
#def Dprint(ligne):
def Dprint(*args, **kwargs):	
	if _debug_all==True:
		print(*args, **kwargs)
		print('--------------------------')
# # # # # # # # # # # # # # # # # # # debug

class br_CDICO(dict):
	  def __missing__(self, key):
		  return ""


import CFichiersRepertoires
from CFichiersRepertoires import CFichiersRepertoires,CFichiers


#fichier binaire http://www.chicoree.fr/w/Lire_et_%C3%A9crire_un_fichier_binaire_avec_Python#C.27est_quoi.2C_un_fichier_binaire.3F

def	TableauToString(tablo):
	texte=""
	for t in tablo:
		if isinstance(t,str):
			texte+=t
		else:
			return None	
	return texte		

class CExtensions(object):
	def __init__(self,rep=''):
		self._Images=['jpg','jpeg','png','gif','tif','tiff','xcf','psd']
		self._Pdf=self._Ps=['pdf','ps']
		self._Videos=self._Ps=['avi','mov','mpg','mpeg','flv','mp4','ogg','webm']
		self._Programmation=['py','c','cpp','pyc']		
		
import struct
class CFichierBinContenu(object):
	""" CLASSE CFichierBinContenu(CFichiers(str(nom))) : contenu d'un fichier fichier """
	
	def __init__(self,fich='',Format="b"):
		Tprint('-* CFichierBinContenu.__init__(fich)')		
		self._fich=CFichiers(fich)
		self.OuvreFichier()
		self._Lignes=None
		#self._f=None
		
		self._format=Format
		self._template=struct.Struct(self._format)
		self._template_taille=struct.calcsize(self._format)
		#print(self._template_taille)
		pass	
		
	def LitUn(self):		
		self._data=self._f.read(self._template_taille)
		return self._data
	
	def Lit(self,template=True,n=0):
		""" Lit(self,True,None)  : ressort un tableau de templates  [ t1,t2 ... ]\
		Lit(self,False,-1) : ressort tout [ t ]\
		Lit(self,False,n>=1) : ressort un tableau de données de taille n  [ t1,t2 ... ]
		"""
		self._datas=[]
		if template==False and n!=-1 and n>0 and n==int(n):
			self._format="b"*n
			self._template=struct.Struct(self._format)
			self._template_taille=struct.calcsize(self._format)
			self._datas=self.Lit(True)			
		
		if template==False and n==-1:
			self._datas=[self._f.read(os.path.getsize(self._fich._NomComplet))]			
		
		if template==True:
			try:
				while True:
					
					
					tmp=self.LitUn()
					if len(tmp)!=self._template_taille:
						self._datas.append(tmp)
						break
					else:
						self._datas.append(tmp)
			except IOError:
				pass
			finally:
				self._f.close()
			
		return self._datas			
		
	def OuvreFichier(self):#V1.2
		Tprint('-* CFichierBinContenu.OuvreFichier()')
		try:
			self._f=open(self._fich._fich,'rb')			
		except:
			print('(WW) impossible d\'ouvrir le fichier "'+self._fich._fich+'"')
		
	def FermeFichier(self):	
		Tprint('-* CFichierBinContenu.FermeFichier()')
		try:
			self._f.close()
		except:
			pass	
		self._f=None		

	def EcritFichier(self,StrFich,Contenu):
		""" CFichierBinContenu.EcritFichier écrire le fichier """
		Tprint('-* CFichierBinContenu.EcritFichier()')
		f=open(StrFich,'wb')
		Dprint(type(f))
		if isinstance(Contenu,str):
			print(Contenu,file=f)
			
		if isinstance(Contenu,list):
			for C in Contenu:
				print(C,file=f)
		f.close()



	"""
	http://www.chicoree.fr/w/Lire_et_%C3%A9crire_un_fichier_binaire_avec_Python
	
	endianness 	enregistrement
	little-endian 	double8 	float4 	float 	float 	long4 	float 	float 	float 	float 	float 	float 	float 	long
	< 	d 	f 	f 	f 	l 	f 	f 	f 	f 	f 	f 	f 	l 
	s = struct.Struct("<dffflfffffffl")
	record = f.read(56)
	s.unpack(record)
	
	
	#long int, long int, unsigned short, unsigned short, unsigned int
	FORMAT = 'llHHI'
	EVENT_SIZE = struct.calcsize(FORMAT)
	in_file.read(EVENT_SIZE)
	(tv_sec, tv_usec, type, code, value) = struct.unpack(FORMAT, event)
	
	print("Event type %u, code %u, value %u at %d.%d" % \
            (type, code, value, tv_sec, tv_usec))
	"""




































	def ZZZLitUnByte(self,StrFich,Contenu):
		""" CFichierBinContenu.LitUnByte le fichier """
		Tprint('-* CFichierBinContenu.EcritFichier()')
		f=open(StrFich,'wb')
		Dprint(type(f))
		if isinstance(Contenu,str):
			print(Contenu,file=f)
			
		if isinstance(Contenu,list):
			for C in Contenu:
				print(C,file=f)
		f.close()




	def ZZLignes(self,SautDeLignesInclus=False):
		""" renvoie un tableau de str contenant \n ou pas V1.1 """
		Tprint('-* CFichierContenu.Lignes(SautDeLignesInclus=False)=>self._Lignes')
		self._Lignes=[]
		if self._f==None:
			self.OuvreFichier()
			
		if SautDeLignesInclus:
			for ligne in self._f:			
				self._Lignes.append(ligne)			
		else:
			for ligne in self._f:			
				self._Lignes.append(ligne[0:-1])
					
		
		return self._Lignes

	def ZzUneLigne(self):#méthode 1
		Tprint("'-* CFichierContenu.UneLigne() méthode 1=>self._UneLigne")
		UneLigne="".join(self.Lignes(True))
		self._UneLigne=UneLigne
		return UneLigne
		
	def ZzUneLigne2(self):#méthode 2
		Tprint("'-* CFichierContenu.UneLigne2() méthode 2=>self._UneLigne2")
		l=self.Lignes()
		UneLigne=""
		for li in l:
			UneLigne+=li+"\n"
		self._UneLigne2=UneLigne
		return UneLigne
		

	def ZZLignes0(self):
		""" renvoie un tableau de str contenant \n <=V1.0 """
		Tprint('-* CFichierContenu.Lignes0')
		self._Lignes=[]
		if self._f==None:
			self.OuvreFichier()
		for ligne in self._f:
			self._Lignes.append(ligne)		
		return self._Lignes
		
			
	def ZZDecoupeEnDeux(self,coupure="begin{document}",_Lignes=None,CoupureIncluse=True,typeuh="TABLEAU"):
		""" ressort resultat=[  ['amchin\n machin\n begin{document}]',['lignes restantes','l2'..]] \n DecoupeEnDeux(self,coupure="begin{document}")"""
		Tprint('-* CFichierContenu.DecoupeEnDeux V1.1 ')
		if typeuh!="STRING":
			typeuh="TABLEAU"
		
		if _Lignes==None:
			if self._Lignes==None:
				self.Lignes()
			_Lignes=self._Lignes
		resultat=[[],[]]
		
		n=0
		while n+1<len(_Lignes) and coupure not in _Lignes[n]:
			n+=1
		if n == len(_Lignes)-1 and coupure not in _Lignes[n]:
			#print(n)
			resultat[0]=_Lignes
			resultat[1]=['']
			Dprint('Coupure'+coupure+' NonTrouvee')
		else:
			resultat[0]=_Lignes[0:n]			
			ligne=_Lignes[n]
			if CoupureIncluse==True:
				res=re.sub("(.*"+coupure+")","\g<1>",ligne)
				if re.sub(".*"+coupure+"(.*)","\g<1>",ligne)=="":
					n=n+1				
			else:
				res=re.sub("(.*)"+coupure,"\g<1>",ligne)				
			resultat[0].append(res)
			
			dech=""			
			if CoupureIncluse!=True:
				dech=re.sub("("+coupure+".*)","\g<1>",ligne)
			else:
				dech=re.sub(coupure+"(.*)","\g<1>",ligne)
					
			resultat[1]=[dech]
			if n+1< len(self._Lignes)+1:
				resultat[1]+=_Lignes[n+1:]
		
		if typeuh=="STRING":
			self._DecoupeEnDeux=[TableauToString(resultat[0]),TableauToString(resultat[1])]			
		if typeuh=="TABLEAU":
			self._DecoupeEnDeux=resultat
		return self._DecoupeEnDeux
				

	def ZZTrouveIntervalleEnLignes(self,debut="begin{document}",fin="end{document}",NbMaxIntervalles=1): #ne prend pas en compte "FIn Debut Fin Debut" dans la lmême ligne
		""" ressort [['begin{document}',''kl','lkmlk','end{document}']] \n TrouveIntervalleEnLignes(self,debut="begin{document}",fin="end{document}",NbMaxIntervalles=1): """
		Tprint('-* CFichierContenu.TrouveIntervalleEnLignes V1.0')
		if self._Lignes==None:
			self.Lignes()
		
		self.Entete=""
		self.Dechets=""
		self.Corps=""	
			
		NbIntervalles=0
		Intervalles=[]
		Intervalle=[]
		# POSITIONS : 0=(recherche debut) [debut 1=(recherche fin) fin ]     2 ...
		POSITION=0
		for ligne in self._Lignes:
			tmp=ligne
			Dprint('=========================================')
			#Dprint("lignes,Intervalles = ",self._Lignes,Intervalles)
			Dprint("ligne,POSITION = ",ligne,POSITION)
			if debut in tmp or fin in tmp:
				while (debut in tmp and POSITION % 2 == 0 ) or (fin in tmp and POSITION % 2 == 1) and (NbIntervalles<NbMaxIntervalles):
					Dprint("1 tmp",POSITION,tmp)
					if POSITION % 2 == 0:					
						while (debut in tmp)and (NbIntervalles<NbMaxIntervalles):
							if fin not in tmp :							
								Intervalle+=[re.sub(".*"+debut,debut,tmp)]
								tmp=re.sub(".*"+debut,"",tmp)
								POSITION+=1
								Dprint("2 tmp",POSITION,tmp)
							if fin in tmp :							
								exit(157)
								Intervalle+=[re.sub(fin+".*",fin,re.sub(".*"+debut,debut,tmp))]
								tmp=re.sub(".*"+debut,"",tmp)
								Intervalles+=[Intervalle]
								NbIntervalles+=1
								Dprint("4 tmp",POSITION,tmp)
								Intervalle=[]
								POSITION+=2
						Dprint("6 tmp",POSITION,tmp)			
					else: #POSITION % 2 == 1:					
						while (fin in tmp)and (NbIntervalles<NbMaxIntervalles):
							Dprint("zz"+tmp+"zz")
							NbIntervalles+=1	
							if debut not in tmp :
								Dprint("bb"+tmp+"bb")	
								Intervalle+=[re.sub(fin+".*",fin,tmp)]
								tmp=re.sub(".*"+fin,"",tmp)
								Intervalles+=[Intervalle]
								Intervalle=[]
								POSITION+=1
								Dprint("3 tmp",POSITION,tmp)
							if debut in tmp :
								Dprint("aa"+tmp+"aa")	
								Intervalle+=[re.sub(fin+".*",fin,tmp)]
								Intervalles+=[Intervalle]
								Dprint(Intervalle)
								Intervalle=[]						
								Intervalle=[re.sub(".*"+debut,debut,tmp)]
								tmp=re.sub(".*"+debut,"",tmp)
								POSITION+=2
								Dprint("5 tmp",POSITION,tmp)
							Dprint("7 tmp",tmp)			
			else:
				if POSITION % 2 == 1:
					Intervalle+=[tmp]
					Dprint("9 tmp",POSITION,tmp)
			if POSITION == 0:
					self.Entete+=tmp	
			if POSITION == 2:
					self.Dechets+=tmp	
		self.Corps=""			
		for t in Intervalle:
			self.Corps+=t
						
		"""				
		n=0				
		for I in Intervalles:
			print("=============================")
			print(n)
			n+=1
			print(I)
		"""	
		self._Intervalles=Intervalles
		return self._Intervalles


		
"""
		
import mysql,datetime
import mysql.connector



cnx = mysql.connector.connect(user='ProtonsEtNeutron', password='feclDW0DenfKSHsd',host='127.0.0.1',database='ProtonsEtNeutron')
cursor = cnx.cursor()
#query = ("SELECT first_name, last_name, hire_date FROM employees "    "WHERE hire_date BETWEEN %s AND %s")
temp="SELECT * FROM `objets` ORDER BY id"
cursor.execute(temp)

Rep_pt=

for (rid) in cursor:
	ligne=(list(rid))
	print ( str(ligne[0]) )
	print(ligne)


"""


def mainmain():
	pass
	
global main

if __name__ == "__main__":
	Dprint("Le programme lancé est "+sys.argv[0])
	
	print(_FonctionDuProgramme)
	print("version:"+_Version)
	
	fich=CFichierBinContenu("/home/bruno/texput.log","bb")
	
	fich.Lit(False,7)
	print(fich._datas)
	exit()
	fich.Lignes()
	#print('ppp',fich._Lignes)
	
	
	#V1.1
	fich.DecoupeEnDeux("end{document}")
	print(fich._DecoupeEnDeux[0])
	print('===================================================================================')
	print(fich._DecoupeEnDeux[1])
	print(len(fich._DecoupeEnDeux[0]),len(fich._DecoupeEnDeux[1]))
	
	"""
	#V1.0
	fich.TrouveIntervalleEnLignes("begin{document}","end{document}")		
	fich.FermeFichier()
	fich.EcritFichier('/tmp/ee',fich._Intervalles[0])
	#print('/tmp/ee',fich._Intervalles[0][0])
	"""
	
	sys.exit()

'''
	print('import CFichiersRepertoires')
	print('from CFichiersRepertoires import CFichiersRepertoires,CFichiers')
	print('fich=CFichiers(nomfich)')
	print('  fich._SEP')
	print('  fich._fich , fich.Valide() , fich.RepNom() ,	fich.FichNom() , FichExt  .FichAvantExt')
	print('rep=CFichiers(nomrep)')
	print('  rep._SEP , rep.Contenu() ')
	print('  rep._rep , rep.Valide() , rep.RepNom() ,	rep.FichNom() self.FichAvantExt')
	
	print('Ext=CExtensions()')
	print("		Ext._Images=['jpg','jpeg','png','gif','tif','tiff','xcf','psd'] \n\
		Ext._Pdf=self._Ps=['pdf','ps'] \n\
		Ext._Videos=self._Ps=['avi','mov','mpg','mpeg','flv','mp4','ogg','webm'] \n\
		Ext._Programmation=['py','c','cpp','pyc'] \n\
		rep.ChercheFichierAvecNom(['s-mathematiques-obligatoire-2016-metropole-suj','/ES'],PasDeCasse=False,Operation='OR')\n\
		")
	rep=CRepertoires('/tmp/ANNALES')
	#rep.ChercheFichierAvecExtension('pdf')
	rep.ChercheFichiersAvecNom(['s-mathematiques-obligatoire-2016-metropole-suj','/ES'],PasDeCasse=False,Operation="AND")
	print([f._fich for f in rep._recherche])
	
	
	
	
	
	
	nom='/tmp/aa/bb/cc/dd/ee/ff/gg/bb.jpg'
	a=CFichiers(nom)
	print("CFichiers("+nom+")._FichExt = "+a._FichExt)
	
	
	
	print("CFichiers("+nom+").FichRelativisee('/tmp/aa/bb') = "+CFichiers(nom).FichRelativisee("/tmp/aa/bb"))
	
	
	print(a.__doc__)
'''	
	


